/*CONSTANTES*/
var BPS = 7; //Bloques por segundo
var MULTIPLICADOR_VELOCIDAD = 1; //Sirve para incrementar la velocidad
var NUM_COMIDAS_SIMULTANEAS = 3; //Número de comidas que se muestran simultaneamente
var MIN_SEGUNDOS_CAMBIO_COMIDA = 5; //Mínimo de segundos que han de pasar para cambiar de sitio la comida
var MAX_SEGUNDOS_CAMBIO_COMIDA = 15; //Máximo número de segundos que han de pasar para cambiar de sitio la comida
var ACCEL_MIN_INC = 15; //inclinación mínima para girar
/*FIN CONSTANTES*/

//Objetos del juego
var pantalla;
var serpiente;
var comidas;

//Control de juego
var interval; //Intervalo para pintar la pantalla
var so; //ServiceObject para sensores
var axisdata = {x:0, y:0}; //Datos del acelerómetro

function accelerometerSensorCallback(id1, id2, result){
	//datos del sensor
	if (result.ReturnValue) {
		axisdata.x = result.ReturnValue.XAxisData;
		axisdata.y = result.ReturnValue.YAxisData;
	}
}

function aleatorio(min, max){
    return parseInt(min, 10) + Math.round( Math.random() * (max - min) );
} 

function setPortrait() {
	if(widget.isrotationsupported) 
		widget.setDisplayPortrait();
}

//Si giramos el móvil, la pantalla sigue en modo "portrait"
window.onresize = function() {
	setPortrait();
}

// Called from the onload event handler to initialize the widget.
function init() {
		
	//Usamos la vista "portrait"
	setPortrait();
	
    // set tab-navigation mode and show softkeys
    // (only if we are in the WRT environment)
    if (window.widget) {
        widget.setNavigationEnabled(false);
        menu.showSoftkeys();
    }
   	
	//Interfaz para obtener datos de sensores
	so = device.getServiceObject("Service.Sensor","ISensor");
	//Buscar acelerómetro
	var result = so.ISensor.FindSensorChannel({
		SearchCriterion: "AccelerometerAxis"
	});

	if(result.ErrorCode == 0 && result.ReturnValue.length == 1){ //result.ErrorMessage contiene el mensaje del error
		//Definir callback para obtener datos del sensor
		so.ISensor.RegisterForNotification ({
			ListeningType: "ChannelData",
			ChannelInfoMap: result.ReturnValue[0]
		}, accelerometerSensorCallback); 
		
		//Creación de la pantalla
		pantalla = new Pantalla(document.getElementById('mainWrapper'), 18, 29);
		
		//Creación de la serpiente
		serpiente = new Serpiente(6);
		
		//Array de comidas:
		comidas = new Array(NUM_COMIDAS_SIMULTANEAS);

		//Realizar una iteración cada 1000/BPS milisegundos
		interval = setInterval('realizarIteracion();', 1000 / (BPS * MULTIPLICADOR_VELOCIDAD));
	}
}

function realizarIteracion(){
	//Mover serpiente
	serpiente.moveByAxisData(axisdata, pantalla);
;
	//Si falta comida, la creamos
	for (var i = 0; i < NUM_COMIDAS_SIMULTANEAS; i++)
		if(!comidas[i] || !comidas[i].bloque.contieneComida())
			crearComida(i);
	
	//Si la serpiente ha muerto, paramos el juego
	if(!serpiente.estaViva())
		clearInterval(interval);
}

function crearComida(index){
	//Obtenemos una posición para pintar la comida (no puede haber otra ya)
	var posX, posY;
	do{
		posX = aleatorio(0, pantalla.numBloquesX - 1);
		posY = aleatorio(0, pantalla.numBloquesY - 1);
	}
	while(pantalla.bloques[posX][posY].tipo != TiposBloque.vacio);
	comidas[index] = new Comida(aleatorio(1,3), pantalla.bloques[posX][posY], aleatorio(MIN_SEGUNDOS_CAMBIO_COMIDA, MAX_SEGUNDOS_CAMBIO_COMIDA));
}
