function Serpiente(tamanyo){
	this.tamanyo = tamanyo;
	this.posicion = {x:0, y:0};
	this.velocidad = {x:0, y:1};
	this.bloques = [];
}

Serpiente.incrementarPosicion = function(posicion, incremento, limite){
	posicion += incremento;
	return posicion >= limite ? 0 : (posicion < 0 ? limite -1 : posicion);
}

Serpiente.prototype.cabeza = function(){
	return this.bloques[this.bloques.length - 1];
}

Serpiente.prototype.moveByAxisData = function(axisdata, pantalla){
	//CALCULAR NUEVA VELOCIDAD
	var velX = this.velocidad.x; var velY = this.velocidad.y;
	if(Math.abs(axisdata.x) > Math.abs(axisdata.y)){
		velX = Math.abs(axisdata.x) >= ACCEL_MIN_INC ? -axisdata.x/Math.abs(axisdata.x) : velX;
		velY = velX != 0 ? 0 : velY;
	}
	else{
		velY = Math.abs(axisdata.y) >= ACCEL_MIN_INC ? axisdata.y/Math.abs(axisdata.y) : velY;
		velX = velY != 0 ? 0 : velX;
	}
	//comprobar que la serpiente sólo gira 90º
	if (velX * this.velocidad.x == -1) {
		velX = 0;
		velY = axisdata.y != 0 ? (axisdata.y/Math.abs(axisdata.y)) : 1;
	}
	else if (velY * this.velocidad.y == -1) {
		velY = 0;
		velX = axisdata.x != 0 ? (-axisdata.x/Math.abs(axisdata.x)) : 1;
	}
	this.velocidad.x = velX;
	this.velocidad.y = velY;
	
	//CALCULAR NUEVA POSICION
	this.posicion.x = Serpiente.incrementarPosicion(this.posicion.x, this.velocidad.x, pantalla.numBloquesX);
	this.posicion.y = Serpiente.incrementarPosicion(this.posicion.y, this.velocidad.y, pantalla.numBloquesY);
	
	//BLOQUE ACTUAL:
	var bloque = pantalla.bloques[this.posicion.x][this.posicion.y];

	//GUARDAR NUEVO BLOQUE (POSICIÓN DE LA CABEZA)
	this.bloques.push(bloque);

	//COMPROBAR SI LA SERPIENTE COME EN ESTA ITERACIÓN
	var hayComida = bloque.contieneComida();
	if (hayComida)
		this.comer(bloque.objeto)

	//BORRAR COLA
	while (this.bloques.length > this.tamanyo) {
		var bloqueCola = this.bloques.shift();
		bloqueCola.set(TiposBloque.vacio);
	}
	
	//PINTAR COLA ACTUAL
	this.bloques[0].set(TiposBloque.serpCola, this);
	
	//PINTAR BLOQUE ANTERIOR COMO CUERPO (YA NO ES CABEZA)
	if(this.bloques.length > 1)
		this.bloques[this.bloques.length - 2].set(TiposBloque.serpCuerpo, this);

	//PINTAR CABEZA
	this.cabeza().set((hayComida ? TiposBloque.serpCabezaComiendo : TiposBloque.serpCabeza), this);
}

Serpiente.prototype.comer = function(comida){
	this.tamanyo += comida.alimento;
	comida.eliminar();
}

Serpiente.prototype.estaViva = function(){
	return true;
}
